package com.fp.persistence.pbpm.gene;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TBPMFLOWS*/
@Entity(name="TbpmFlows")
@Table(name="TBPMFLOWS")
public class TbpmFlows extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TbpmFlows
*/
@EmbeddedId
private TbpmFlowsKey pk;
@Column(name="DESCRIPTION", nullable=true)

/**
* Descripcion del flujo
*/
private String description;

@Column(name="RECORDVERSION", nullable=true)

/**
* Optimistick locking del registro
*/
private Integer recordversion;

/**Contructor por defecto*/
public TbpmFlows(){
}
/**Contructor de TbpmFlows
@param pPk Clave Primaria del entity
*/
public TbpmFlows(TbpmFlowsKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TbpmFlows
*/
public static TbpmFlows find(EntityManager pEntityManager,TbpmFlowsKey pKey) throws Exception{
    TbpmFlows obj = pEntityManager.find(TbpmFlows.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TbpmFlows
@return El objeto que referencia a la Clave primaria de TbpmFlows
*/
public TbpmFlowsKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TbpmFlows
@param pPk El objeto que referencia a la nueva Clave primaria de TbpmFlows
*/
public void setPk(TbpmFlowsKey pPk){
  pk=pPk;
}
/**Obtiene el valor de description
@return valor de description*/
public String getDescription(){
  return description;
}
/**Fija el valor de description
@param pDescription nuevo Valor de description*/
public void setDescription(String pDescription){
  description=pDescription;
}

/**Obtiene el valor de recordversion
@return valor de recordversion*/
public Integer getRecordversion(){
  return recordversion;
}
/**Fija el valor de recordversion
@param pRecordversion nuevo Valor de recordversion*/
public void setRecordversion(Integer pRecordversion){
  recordversion=pRecordversion;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TbpmFlows))return false;
    TbpmFlows that = (TbpmFlows) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TbpmFlows
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TbpmFlows
*/
public Object createInstance(){
 TbpmFlows instance=new TbpmFlows();	
 instance.setPk(new TbpmFlowsKey());
 return instance;
}
/**Clona la entidad TbpmFlows
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TbpmFlows p=(TbpmFlows)this.clone();
  p.setPk((TbpmFlowsKey)this.pk.cloneMe());
  return p;
}
}
